function [ W ] = greedy_MI(SP, H,A,a)
Nr = SP.Nr;
Nrf = SP.Nrf;
p = SP.p;

W = [];

count = 0;
for i=1:Nrf
    temp = W;
    MI = [];
    for j=1:Nr-count
        W_temp = [temp,A(:,j)];
        Hb = W_temp'*H;
        Rqq = a*(1-a)*diag(diag(p*Hb*Hb' + W_temp'*W_temp));
        MI(j) = log2( det( eye(i) + p*a^2*pinv(a^2*W_temp'*W_temp + Rqq)*Hb*Hb' ) );
    end
    [~,idx] = max(MI);
    W = [W, A(:,idx)];
    A(:,idx) = [];
    count = count + 1;
end


%size(Hs)


%Hb = W'*H;
%[r, c] = size(Hb);
%Rqq = a*(1-a)*diag(diag(p*Hb*Hb' +W'*W));
%MI = log2( det( eye(r) + p*a^2*pinv(a^2*W'*W+Rqq)*Hb*Hb' ) );